#pragma once

#include "CoreMinimal.h"
#include "Perk.h"
#include "InfectiousFright.generated.h"

class ASurvivor;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class DBDCOMPETENCE_API UInfectiousFright : public UPerk
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	bool _revealPlayerInTerrorRadius;

	UPROPERTY(BlueprintReadWrite, ReplicatedUsing=OnRep_PerkActivationCount, Transient, meta=(AllowPrivateAccess=true))
	uint8 _perkActivationCount;

	UPROPERTY(BlueprintReadWrite, Replicated, Transient, meta=(AllowPrivateAccess=true))
	TArray<ASurvivor*> _revealedSurvivors;

	UPROPERTY(BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	ASurvivor* _targetSurvivor;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_PerkActivationCount();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UInfectiousFright();
};

FORCEINLINE uint32 GetTypeHash(const UInfectiousFright) { return 0; }
